<template>
  <main>
    <mt-page-title :with-border="false" :with-padding="true">
      <h1 class="has-text-weight-bold is-size-3">Disponibilité de mon unité</h1>
    </mt-page-title>
    <mt-box padding="0">
      <article class="mt-box-content">
        <form @submit.prevent="moisSelectionne">
          <b-message type="is-danger" size="is-small" class="is-size-7" :active="dateInError">
            La date de fin est antérieure à la date de début
          </b-message>
          <section class="mt-fields-section columns">
            <b-field label="Début de la période" class="column is-one-third">
              <b-datepicker
                v-model="start"
                placeholder="Sélectionnez une date de debut"
                :first-day-of-week="1"
                :month-names="monthNames"
                :day-names="dayNames"
                :date-parser="dateParse"
                editable
                icon="calendar-today"
                class="mt-input"
                @input="moisSelectionneDebut"
              />
            </b-field>

            <b-field label="Fin de la période" class="column is-one-third">
              <b-datepicker
                v-model="end"
                placeholder="Sélectionnez une date de fin"
                :first-day-of-week="1"
                :month-names="monthNames"
                :day-names="dayNames"
                :date-parser="dateParse"
                editable
                icon="calendar-today"
                class="mt-input"
                @input="moisSelectionneFin"
              />
            </b-field>

            <b-dropdown aria-role="list" class="column mt-right-bottom">
              <b-button
                slot="trigger"
                class="button mt-button is-size-8 is-primary has-text-weight-semibold"
                icon-left="download"
              >
                <span>Exporter</span>
              </b-button>

              <b-dropdown-item aria-role="listitem" @click="exportCsvComplet()">
                <b-icon icon="download" size="is-small"></b-icon>
                CSV : Pax disponibles tous les jours pour la période
              </b-dropdown-item>
              <b-dropdown-item aria-role="listitem" @click="exportCsv()">
                <b-icon icon="download" size="is-small"></b-icon>
                CSV : Diponibilités de tous les Pax pour la période
              </b-dropdown-item>
            </b-dropdown>
          </section>
        </form>
        <mt-filtre-categorie
          :fullsize="utilisateursGroup.fullsize"
          :categories="utilisateursGroup.corps"
          :groupes="groupes"
          :groupe-selected="groupeSelected"
          @select-all="viderFiltre"
          @select-categorie="filtreCategorie"
          @select-groupe="filtrerGroupe"
          @unselect-groupe="unfiltrerGroupe"
        >
          <template>
            <b-dropdown v-model="selectedDispos" aria-role="list" class="is-hidden-mobile" @input="getListUtilisateur">
              <template v-if="selectedDispos === 1" #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce is-disponible /> Disponibles ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <template v-else-if="selectedDispos === 2" #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce is-indisponible /> Non disponibles ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <template v-else-if="selectedDispos === 3" #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce /> Non renseignés ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <template v-else #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce /> Tous les pax ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <b-dropdown-item :value="0" aria-role="listitem"> <mt-disponibilite-puce /> --- </b-dropdown-item>
              <b-dropdown-item :value="1" aria-role="listitem">
                <mt-disponibilite-puce is-disponible /> Disponibles
              </b-dropdown-item>
              <b-dropdown-item :value="2" aria-role="listitem">
                <mt-disponibilite-puce is-indisponible /> Non disponibles
              </b-dropdown-item>
              <b-dropdown-item :value="3" aria-role="listitem">
                <mt-disponibilite-puce /> Non renseignés
              </b-dropdown-item>
            </b-dropdown>
          </template>
          <template v-slot:bas>
            <b-dropdown
              v-model="selectedDispos"
              aria-role="list"
              class="is-hidden-tablet column"
              @input="getListUtilisateur"
            >
              <template v-if="selectedDispos === 1" #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce is-disponible /> Disponibles ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <template v-else-if="selectedDispos === 2" #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce is-indisponible /> Non disponibles ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <template v-else-if="selectedDispos === 3" #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce /> Non renseignés ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <template v-else #trigger>
                <b-button type="is-primary" icon-right="menu-down" class="mt-btn-dispo">
                  <mt-disponibilite-puce /> Tous les pax ({{ listUtilisateurs.length }})
                </b-button>
              </template>
              <b-dropdown-item :value="0" aria-role="listitem"> <mt-disponibilite-puce /> --- </b-dropdown-item>
              <b-dropdown-item :value="1" aria-role="listitem">
                <mt-disponibilite-puce is-disponible /> Disponibles
              </b-dropdown-item>
              <b-dropdown-item :value="2" aria-role="listitem">
                <mt-disponibilite-puce is-indisponible /> Non disponibles
              </b-dropdown-item>
              <b-dropdown-item :value="3" aria-role="listitem">
                <mt-disponibilite-puce /> Non renseignés
              </b-dropdown-item>
            </b-dropdown>
          </template>
        </mt-filtre-categorie>
        <mt-list v-slot="{ item: filtre }" :list="listUtilisateurs">
          <mt-list-item>
            <div class="columns is-vcentered">
              <div class="column is-narrow">
                <template v-if="estRenseignerPeriode(filtre)">
                  <mt-disponibilite-puce v-if="estDisponiblePeriode(filtre)" is-disponible />
                  <mt-disponibilite-puce v-else-if="!estDisponiblePeriode(filtre)" is-indisponible />
                </template>
                <mt-disponibilite-puce v-else-if="!estRenseignerPeriode(filtre)" />
              </div>
              <div class="column">
                <mt-utilisateur :utilisateur="filtre" />
              </div>
              <div class="column  is-over">
                {{ filtre.email }}
              </div>
              <div class="column">
                {{ filtre.telephone }}
              </div>
              <div class="action-buttons">
                <b-button
                  type="is-text"
                  icon-left="message-reply-text"
                  title="Consulter l'historique des messages"
                  @click="openDisponibiliteCommentaire(filtre)"
                >
                </b-button>
              </div>
            </div>
          </mt-list-item>
        </mt-list>
        <footer>
          <mt-message-info>Ces personnels sont disponibles tous les jours durant cette période.</mt-message-info>
        </footer>
        <section class="mt-details-dispo">
          <article v-for="(jours, index) in dispoDetails" :key="index" class="mt-details-dispo-item">
            {{ getDay(jours.dateDebut) }}

            <div class="mt-details-dispo-popup">
              <span class="mt-details-pastilles">{{ joursDetail(jours) }}</span>
              <ul>
                <li v-for="(dispo, index2) in jours.details" :key="index2">
                  <mt-disponibilite-puce is-disponible />
                  <mt-utilisateur :utilisateur="dispo.utilisateur" />
                </li>
              </ul>
            </div>
          </article>
        </section>
      </article>
    </mt-box>
    <mt-modal :ouvert.sync="openCommentaireDispo">
      <div v-if="isDisponible()">
        <div class="columns is-centered">
          <div class="mt-commentaires column  is-flex">
            <p><b>Disponibilité / Indisponibilité :</b>{{ nombreDisponIndispo() }}</p>
            <mt-commentaire
              v-for="(disponibilite, index) in disponibilites"
              :key="`disponibilites${index}`"
              :redacteur="disponibilite.utilisateur"
              :commentaire="disponibilite"
            ></mt-commentaire>
          </div>
        </div>
      </div>
      <div v-else class="columns is-vcentered">
        Aucun commentaire référencé dans la période saisie.
      </div>
    </mt-modal>
  </main>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtBox from '~/components/base/box';
import MtFiltreCategorie from '~/components/filtre/filtre-categorie/index';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';
import MtCommentaire from '~/components/activity/partipation/commentaire';
import MtModal from '~/components/modal/mt-modal';
import userMixin from '~/components/mixins/userMixin';
import { createExportLink, dateFileFormat } from '~/components/mixins/csvMixin';
import MtMessageInfo from '~/components/base/message/mt-message-info';

export default {
  components: {
    MtDisponibilitePuce,
    MtUtilisateur,
    MtModal,
    MtMessageInfo,
    MtFiltreCategorie,
    MtPageTitle,
    MtList,
    MtListItem,
    MtBox,
    MtCommentaire,
  },
  mixins: [DayMonthMixin, userMixin],
  data() {
    return {
      disponibilites: [],
      unite: null,
      openCommentaireDispo: false,
      idCorps: null,
      groupeSelected: null,
      enabled: '',
      selectedDispos: 0,
    };
  },
  computed: {
    dateInError() {
      if (!this.start || !this.end) {
        return false;
      }
      return !DateTime.fromJSDate(this.start).hasSame(DateTime.fromJSDate(this.end), 'day') && this.end < this.start;
    },
    idGroupeSelected() {
      if (this.groupeSelected) {
        return this.groupeSelected.id;
      }
      return null;
    },
  },
  watch: {
    organisme: {
      handler() {
        this.monUnite();
        this.moisSelectionne();
      },
    },
  },
  async asyncData({ $api, query }) {
    const start = query['start-date'] ? new Date(query['start-date']) : new Date();
    start.setHours(8);
    const end = query['end-date'] ? new Date(query['end-date']) : new Date();
    end.setHours(18);

    const disponibilitesCompleteReq = $api.organisme().disponibilitesComplete(start.toISOString(), end.toISOString());
    const disponibilitesDetailReq = $api.organisme().disponibilitesEntre(start.toISOString(), end.toISOString());
    const [dispoDetails, disponibilitesComplete, utilisateursGroup, groupes] = await Promise.all([
      disponibilitesDetailReq,
      disponibilitesCompleteReq,
      $api.organisme().utilisateursFilterWithMyGroupes(),
      $api.utilisateur().groupes(),
    ]);
    const listUtilisateurs = utilisateursGroup.filtrer;
    const pastilleReq = [];
    for (let i = 0; i < listUtilisateurs.length; i += 1) {
      pastilleReq[i] = $api.disponibilites.disponibiliteEntre(
        listUtilisateurs[i].id,
        start.toISOString(),
        end.toISOString(),
      );
    }
    const pastille = await Promise.all(pastilleReq);
    return {
      start,
      end,
      utilisateursGroup,
      disponibilitesComplete,
      dispoDetails,
      groupes,
      listUtilisateurs,
      pastille,
    };
  },
  methods: {
    filtrerGroupe(groupe) {
      this.groupeSelected = groupe;
      this.monUnite();
    },
    unfiltrerGroupe() {
      this.groupeSelected = null;
      this.monUnite();
    },

    moisSelectionne() {
      if (this.start > this.end) {
        this.moisSelectionneDebut();
      } else {
        this.moisSelectionneFin();
      }
    },

    async moisSelectionneDebut() {
      if (this.start && this.end) {
        this.start.setHours(8);
        this.end.setHours(18);
        if (this.start > this.end) {
          this.end = this.start;
        }
        const disponibilitesCompleteReq = this.$api
          .organisme()
          .disponibilitesComplete(this.start.toISOString(), this.end.toISOString(), this.idCorps);
        const disponibilitesDetailReq = this.$api
          .organisme()
          .disponibilitesEntre(this.start.toISOString(), this.end.toISOString());
        [this.dispoDetails, this.disponibilitesComplete] = await Promise.all([
          disponibilitesDetailReq,
          disponibilitesCompleteReq,
        ]);
        await this.miseAjourPasitille();
        this.getListUtilisateur();
      }
    },

    async moisSelectionneFin() {
      if (this.start && this.end) {
        this.start.setHours(8);
        this.end.setHours(18);
        if (this.end < this.start) {
          this.start = this.end;
        }
        const disponibilitesCompleteReq = this.$api
          .organisme()
          .disponibilitesComplete(this.start.toISOString(), this.end.toISOString(), this.idCorps);
        const disponibilitesDetailReq = this.$api
          .organisme()
          .disponibilitesEntre(this.start.toISOString(), this.end.toISOString());
        [this.dispoDetails, this.disponibilitesComplete] = await Promise.all([
          disponibilitesDetailReq,
          disponibilitesCompleteReq,
        ]);
        await this.miseAjourPasitille();
        this.getListUtilisateur();
      }
    },

    majEffectifPrevisionnelDebut() {
      this.$emit('majEffectifPrevisionnel');
    },
    majEffectifPrevisionnelFin() {
      if (this.activite.dateFin < this.activite.dateDebut) {
        this.activite.dateDebut = this.activite.dateFin;
      }
      this.$emit('majEffectifPrevisionnel');
    },

    async openDisponibiliteCommentaire(utilisateurDispo) {
      this.openCommentaireDispo = true;
      this.disponibilites = await this.$api.disponibilites.disponibilitesCommentaireEntre(
        utilisateurDispo.id,
        this.start.toISOString(),
        this.end.toISOString(),
      );
    },
    async monUnite() {
      this.utilisateursGroup = await this.$api
        .organisme()
        .utilisateursFilterWithMyGroupes(this.idCorps, this.idGroupeSelected);
      await this.miseAjourPasitille();
      this.getListUtilisateur();
    },
    async miseAjourPasitille() {
      const pastilleReq = [];
      for (let i = 0; i < this.utilisateursGroup.filtrer.length; i += 1) {
        pastilleReq[i] = this.$api.disponibilites.disponibiliteEntre(
          this.utilisateursGroup.filtrer[i].id,
          this.start.toISOString(),
          this.end.toISOString(),
        );
      }
      this.pastille = await Promise.all(pastilleReq);
    },
    joursDetail(jours) {
      if (jours.details) {
        return jours.details.length;
      }
      return 0;
    },
    isDisponible() {
      return this.disponibilites && this.disponibilites.length > 0;
    },
    nombreDisponIndispo() {
      let nombresDispo = 0;
      if (this.disponibilites) {
        nombresDispo = this.disponibilites.length;
      }
      return nombresDispo;
    },
    exportCsvComplet() {
      if (this.start && this.end) {
        this.$api
          .organisme()
          .exportDisponibilitesComplete(this.start.toISOString(), this.end.toISOString())
          .then((response) => {
            createExportLink(response, this.fileName('export-disponibilite-complet-entre'));
          });
      }
    },
    exportCsv() {
      if (this.start && this.end) {
        this.$api
          .organisme()
          .exportDisponibilites(this.start.toISOString(), this.end.toISOString())
          .then((response) => {
            createExportLink(response, this.fileName('export-disponibilite-entre'));
          });
      }
    },
    fileName(name) {
      return `${this.$api.organisme().id()}-${dateFileFormat(new Date())}-${name}-${dateFileFormat(
        this.start,
      )}-et-${dateFileFormat(this.end)}.csv`;
    },
    filtreCategorie(corps) {
      this.idCorps = corps.id;
      this.monUnite();
      this.moisSelectionne();
    },
    viderFiltre() {
      this.idCorps = null;
      this.monUnite();
      this.moisSelectionne();
    },
    getDay(dateString) {
      const date = new Date(dateString);
      return `${date.getDate()}/${date.getMonth() + 1}`;
    },
    estDisponiblePeriode({ id }) {
      let result;
      for (let i = 0; i < this.pastille.length; i += 1) {
        if (this.pastille[i].utilisateur.id === id) {
          if (this.pastille[i].estDisponible && this.pastille[i].estRenseigner) {
            result = this.pastille[i].estDisponible;
          }
        }
      }
      return result;
    },
    estRenseignerPeriode({ id }) {
      let result;
      for (let i = 0; i < this.pastille.length; i += 1) {
        if (this.pastille[i].utilisateur.id === id) {
          result = this.pastille[i].estRenseigner;
        }
      }
      return result;
    },
    getListUtilisateur() {
      if (this.selectedDispos === 0) {
        this.listUtilisateurs = this.utilisateursGroup.filtrer;
      } else {
        this.listUtilisateurs = [];
        for (let i = 0; i < this.utilisateursGroup.filtrer.length; i += 1) {
          if (this.selectedDispos === 1) {
            if (this.pastille[i] && this.pastille[i].estDisponible) {
              this.listUtilisateurs.push(this.utilisateursGroup.filtrer[i]);
            }
          }
          if (this.selectedDispos === 2) {
            if (this.pastille[i] && !this.pastille[i].estDisponible && this.pastille[i].estRenseigner) {
              this.listUtilisateurs.push(this.utilisateursGroup.filtrer[i]);
            }
          }
          if (this.selectedDispos === 3) {
            if (this.pastille[i] && !this.pastille[i].estDisponible && !this.pastille[i].estRenseigner) {
              this.listUtilisateurs.push(this.utilisateursGroup.filtrer[i]);
            }
          }
        }
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.commentaire {
  text-align: justify;
  word-break: break-all;
}

/deep/.switch-color {
  font-size: 1rem;

  input[type='checkbox'] + .check {
    width: 2.5em;
    height: 1.5em;
    padding: 0;
    font-size: 1rem;

    /*border: 1.5px solid $periwinkle-light;
    background-color: $pale-grey;*/

    border: 1.5px solid $soft-blue;
    background-color: $periwinkle-light;

    transition-property: background-color, border-color;
    transition-duration: 0.3s;
    border-radius: 2.5em;
    box-sizing: border-box;
    transform: translate3d(0, 0, 0);

    &::before {
      background-color: $white;
      box-shadow: unset;
      height: 1.25em;
      width: 1.25em;
      box-sizing: content-box;
      border-radius: 100%;
    }
  }

  input[type='checkbox']:focus + .check,
  input[type='checkbox']:hover + .check {
    border-color: $soft-blue;
    background-color: $periwinkle-light;
  }

  input[type='checkbox']:checked:focus + .check,
  input[type='checkbox']:focus + .check {
    box-shadow: 0 0 0 2px rgba($periwinkle-light, 0.5);
  }

  input[type='checkbox']:checked:focus + .check,
  input[type='checkbox']:checked + .check {
    border-color: $soft-blue;
    background-color: $soft-blue;

    &::before {
      transform: translate3d(calc(100% - 2.5px), 0, 0);
    }
  }

  .control-label {
    font-size: 0.875em;
    color: $soft-blue;
    transition-property: color;
    transition-duration: 0.3s;
  }

  input[type='checkbox']:hover ~ .control-label {
    color: $soft-blue;
  }

  input[type='checkbox']:checked ~ .control-label {
    color: $soft-blue;
  }
}

.mt-filter-liste {
  margin-top: 1rem;
  text-align: center;
}
footer {
  padding: 0.5rem 0;
  margin-bottom: 1rem;
}
.mt-right-bottom {
  margin-bottom: 0.75rem;
}
.mt-commentaires {
  display: flex;
  flex-direction: column;

  p {
    color: $grey-dark;
    font-size: 0.75rem;
    margin: 0 0.75rem;
  }
  b {
    padding-right: 0.75rem;
  }
}
.mt-details-dispo {
  display: flex;
  flex-wrap: wrap;

  .mt-details-pastilles,
  .mt-details-dispo-item {
    color: white;
    background-color: $grey-light;
    display: flex;
    padding: 0.2em 1em;
    border-radius: 2em;
    align-items: center;
    justify-content: center;
    margin: 0.1em;
    cursor: default;
    font-size: 0.8rem;
  }
  .mt-details-dispo-item {
    position: relative;

    &:hover {
      .mt-details-dispo-popup {
        display: flex;
        align-items: flex-start;
      }
    }

    .mt-details-pastilles {
      margin-right: 1rem;
      padding: 0.1em 0.6em;
    }

    .mt-details-dispo-popup {
      align-self: flex-start;
      position: absolute;
      display: none;
      background-color: white;
      padding: 1.5em 1.5em;
      box-shadow: 0 2px 8px -1px rgba(100, 109, 232, 0.2);
      color: $grey;
      min-width: 20rem;
      border-radius: $border-radius;
      margin: 2em;
      z-index: 1;

      li {
        display: flex;
        align-items: center;
      }

      /deep/ .mt-disponibilite-puce {
        margin-right: 0.5em;
      }
    }
  }
}
.is-over {
  overflow: hidden;
  text-overflow: ellipsis;
}
.mt-btn-dispo {
  border-radius: 2rem;
  width: calc(100% - 4px);
  background-color: $primary;
  color: white;
  font-size: $size-7;
  padding: 0.3em 1em;
  margin: 0 0.25em;
  cursor: pointer;
  transition-property: background-color, color;
  transition-duration: 0.3s;
  border: solid 1px $primary;
  position: relative;
  &.is-primary {
    background-color: $pale-grey;
    color: #666ee8;
  }
  &:hover {
    background-color: $periwinkle-blue;
    color: white;
  }
}
</style>
